*** molecule.h	2004/05/07 19:46:16	1.1
--- molecule.h	2005/01/16 20:25:16
***************
*** 155,167 ****
  #define WideKnotFlag    0x0e
  
  /* Atom Flags */
! #define SphereFlag      0x02     /* Sphere representation */
! #define HeteroFlag      0x04     /* HETATM record         */
! #define HydrogenFlag    0x08     /* Hydrogen atom         */
  #define NormAtomFlag    0x10
  #define NonBondFlag     0x20
! #define BreakFlag       0x40     /* Break in backbone     */
! #define StarFlag        0x80     /* Star representation   */
  
  /* Bond Flags */
  #define WireFlag        0x02     /* Depth-cued wireframe         */
--- 158,174 ----
  #define WideKnotFlag    0x0e
  
  /* Atom Flags */
! #define SphereFlag      0x02     /* Sphere representation         */
! #define HeteroFlag      0x04     /* HETATM record                 */
! #define HydrogenFlag    0x08     /* Hydrogen atom                 */
  #define NormAtomFlag    0x10
  #define NonBondFlag     0x20
! #define BreakFlag       0x40     /* Break in backbone              */
! #define StarFlag        0x80     /* Star representation            */
! #define TouchFlag       0x100    /* Touch by probe                 */
! #define ExpandFlag      0x200    /* Expand by probe radius         */
! #define SurfBondFlag    0x400    /* Atom is part of a surface bond */
! 
  
  /* Bond Flags */
  #define WireFlag        0x02     /* Depth-cued wireframe         */
***************
*** 215,221 ****
          void   *label;                    /* Atom Label Structure  */
          Byte   elemno;                    /* Atomic Number         */
          int    refno;                     /* ElemDesc index number */
!         Byte   flag;                      /* Database flags        */
          char   altl;                      /* Alternate Location    */
          short  irad;                      /* Image Radius          */
          short  mbox;                      /* Shadow Casting NOnce  */
--- 222,228 ----
          void   *label;                    /* Atom Label Structure  */
          Byte   elemno;                    /* Atomic Number         */
          int    refno;                     /* ElemDesc index number */
!         short  flag;                      /* Database flags        */
          char   altl;                      /* Alternate Location    */
          short  irad;                      /* Image Radius          */
          short  mbox;                      /* Shadow Casting NOnce  */
***************
*** 223,228 ****
--- 230,236 ----
          short  visited;                   /* For bond rotation     */
          short  nbonds;                    /* For bond rotation     */ 
          struct _Atom __far *bonds[MaxBonds];
+         void   *surfbonds;                /* Surface bonds list    */
      } RAtom;
  
  
***************
*** 235,244 ****
          short aradius;                   /* World Alt Radius      */
          short iarad;                     /* Image Alt Radius      */
          short col;                       /* Bond Colour           */
!         Byte  flag;                      /* Database flags        */
          char  altl;                      /* Bond Alternate Loc    */
      } Bond;
  
  typedef struct _Group {
          struct _Group __far *gnext;       /* Linked list of groups */
          RAtom __far *alist;                /* Linked list of atoms  */
--- 243,267 ----
          short aradius;                   /* World Alt Radius      */
          short iarad;                     /* Image Alt Radius      */
          short col;                       /* Bond Colour           */
!         short flag;                      /* Database flags        */
          char  altl;                      /* Bond Alternate Loc    */
      } Bond;
  
+ typedef struct _SurfBond {
+         struct _SurfBond __far *sbnext;   /* Linked list of bonds  */
+         RAtom  __far *srcatom;            /* Source Atom Ptr       */
+         RAtom  __far *dstatom;            /* Destination Atom Ptr  */
+         Long   sxyz;                      /* Bond length           */
+         Long   wp;                        /* Torus waist           */
+         Long   w1,w2;                     /* Torus throats         */
+         Long   u1,u2;                     /* Probe offsets         */
+         Long   t1,t2;                     /* Torus offsets         */
+         short  col;                       /* Bond Colour           */
+         short  flag;                      /* Database flags        */
+         char   altl;                      /* Bond Alternate Loc    */
+     } SurfBond;
+ 
+ 
  typedef struct _Group {
          struct _Group __far *gnext;       /* Linked list of groups */
          RAtom __far *alist;                /* Linked list of atoms  */
***************
*** 251,257 ****
          char  sinsert;                    /* Secondary insert code */
          Byte  refno;                      /* Residue index number  */
          Byte  struc;                      /* Secondary Structure   */
!         Byte  flag;                       /* Database flags        */
          short model;                      /* Group Model Number    */
      } Group;
   
--- 274,280 ----
          char  sinsert;                    /* Secondary insert code */
          Byte  refno;                      /* Residue index number  */
          Byte  struc;                      /* Secondary Structure   */
!         short flag;                       /* Database flags        */
          short model;                      /* Group Model Number    */
      } Group;
   
***************
*** 286,292 ****
          short aradius;                    /* World Alt Radius      */
          short iarad;                      /* Image Alt Radius      */
          Char offset;                      /* Signed Offset            */
!         Byte flag;                        /* Database flags           */
          Byte col;                         /* Hydrogen bond colour     */
          char altl;                        /* Bond Alternate Loc       */
      } HBond;
--- 309,315 ----
          short aradius;                    /* World Alt Radius      */
          short iarad;                      /* Image Alt Radius      */
          Char offset;                      /* Signed Offset            */
!         short flag;                       /* Database flags           */
          Byte col;                         /* Hydrogen bond colour     */
          char altl;                        /* Bond Alternate Loc       */
      } HBond;
***************
*** 296,301 ****
--- 319,325 ----
          HBond __far *hlist;               /* Linked list of hbonds    */
          Chain __far *clist;               /* Linked list of chains    */
          Bond __far *blist;                /* Linked list of bonds     */
+         SurfBond __far *sblist;           /* Linked list of surf bonds*/
      } Molecule;
  
  
***************
*** 345,350 ****
--- 369,375 ----
          double cell[6];
  
          Long bondcount;
+         Long srfbondcount;
          int chaincount;
          int ssbondcount;
          int hbondcount;
***************
*** 483,488 ****
--- 508,514 ----
  
  int HBondChainsFlag;
  
+ SurfBond __far *FreeSurfBond;
  HBond __far *FreeHBond;
  Bond __far *FreeBond;
  Bond __far *NewBond;
***************
*** 529,534 ****
--- 555,561 ----
  
  extern int HBondChainsFlag;
  
+ extern SurfBond __far *FreeSurfBond;
  extern HBond __far *FreeHBond;
  extern Bond __far *FreeBond;
  extern Bond __far *NewBond;
***************
*** 558,563 ****
--- 585,591 ----
  void CreateBondOrder( Long, Long );
  void CreateNewBond( Long, Long );
  void CreateMoleculeBonds( int, int, int );
+ void CreateSurfaceBonds( void );
  RAtom __far *FindCysSulphur( Group __far *group );
  void FindDisulphideBridges( void );
  void TestDisulphideBridge( Group __far *, Group __far *, RAtom __far * );
*** mswin31.c	2005/01/16 20:12:09	1.2
--- mswin31.c	2005/01/16 20:25:17
***************
*** 410,415 ****
--- 416,422 ----
    ModifyMenu(hMenu,IDM_RIBBONS,  MF_STRING,IDM_RIBBONS,  MsgStrs[StrMRibbons]);
    ModifyMenu(hMenu,IDM_STRANDS,  MF_STRING,IDM_STRANDS,  MsgStrs[StrMStrands]);
    ModifyMenu(hMenu,IDM_CARTOONS, MF_STRING,IDM_CARTOONS, MsgStrs[StrMCartoon]);
+   ModifyMenu(hMenu,IDM_MOLSURF,  MF_STRING,IDM_MOLSURF,  MsgStrs[StrMMolSurf]);
  
    ModifyMenu(hMenu,IDM_MONO,     MF_STRING,IDM_MONO,     MsgStrs[StrMMonochr]);
    ModifyMenu(hMenu,IDM_CPK,      MF_STRING,IDM_CPK,      MsgStrs[StrMCPK]);
*** multiple.c	2004/05/07 19:46:16	1.1
--- multiple.c	2005/01/16 20:25:17
***************
*** 218,340 ****
  
     /* graphics.h */
      
!     { DialValue,          sizeof (DialValue),      0},
  
      /* molecule.h */
!     { &Info,              sizeof (Info),           0},
!     { &MainGroupCount,    sizeof (MainGroupCount), 0},
!     { &HetaGroupCount,    sizeof (HetaGroupCount), 0},
!     { &MainAtomCount,     sizeof (MainAtomCount),  0},
!     { &HetaAtomCount,     sizeof (HetaAtomCount),  0},
!     { &CisBondCutOff,     sizeof (CisBondCutOff),  0},
!     { &MinX,              sizeof (MinX),           0},
!     { &MinY,              sizeof (MinY),           0},
!     { &MinZ,              sizeof (MinZ),           0},
!     { &MaxX,              sizeof (MaxX),           0},
!     { &MaxY,              sizeof (MaxY),           0},
!     { &MaxZ,              sizeof (MaxZ),           0},
!     { &HMinMaxFlag,       sizeof (HMinMaxFlag),    0},
!     { &MMinMaxFlag,       sizeof (MMinMaxFlag),    0},
!     { &MinMainTemp,       sizeof (MinMainTemp),    0},
!     { &MaxMainTemp,       sizeof (MaxMainTemp),    0},
!     { &MinHetaTemp,       sizeof (MinHetaTemp),    0},
!     { &MaxHetaTemp,       sizeof (MaxHetaTemp),    0},
!     { &MinMainRes,        sizeof (MinMainRes),     0},
!     { &MaxMainRes,        sizeof (MaxMainRes),     0},
!     { &MinHetaRes,        sizeof (MinHetaRes),     0},
!     { &MaxHetaRes,        sizeof (MaxHetaRes),     0},
!     { &MinAltl,           sizeof (MinAltl),        0},
!     { &MaxAltl,           sizeof (MaxAltl),        0},
!     { &CurMolecule,       sizeof (CurMolecule),    0},
!     { &CurChain,          sizeof (CurChain),       0},
!     { &CurGroup,          sizeof (CurGroup),       0},
!     { &CurAtom,           sizeof (CurAtom),        0},
!     { &IntList,           sizeof (IntList),        0},
!     { &Database,          sizeof (Database),       0},
!     { UserMask,           sizeof (UserMask),       0},
!     { &MinHBondDist,      sizeof (MinHBondDist),   0},
!     { &MaxHBondDist,      sizeof (MaxHBondDist),   0},
!     { &MinBondDist,       sizeof (MinBondDist),    0},
!     { &MaxBondDist,       sizeof (MaxBondDist),    0},
!     { &ElemNo,            sizeof (ElemNo),         0},
!     { &ResNo,             sizeof (ResNo),          0},
!     { &HasHydrogen,       sizeof (HasHydrogen),    0},
!     { &MaskCount,         sizeof (MaskCount),      0},
!     { &NMRModel,          sizeof (NMRModel),       0},
!     { &NullBonds,         sizeof (NullBonds),      0},
!     { &MarkAtoms,         sizeof (MarkAtoms),      0},
!     { &HBondChainsFlag,   sizeof (HBondChainsFlag), 0},
  
      /* render.h */
!     { &VoxelsClean,       sizeof (VoxelsClean),    0},
  
      /* repres.h */
!     { &DotPtr,            sizeof (DotPtr),         0},
  
      /* command.h */
  
!     { &SelectCount,       sizeof (SelectCount),    0},
       
      /* transfor.h */
!     { &LastRX,            sizeof (LastRX),         0},
!     { &LastRY,            sizeof (LastRY),         0},
!     { &LastRZ,            sizeof (LastRZ),         0},
!     { &LastTX,            sizeof (LastTX),         0},
!     { &LastTY,            sizeof (LastTY),         0},
!     { &LastTZ,            sizeof (LastTZ),         0},
!     { &CenX,              sizeof (CenX),           0},
!     { &CenY,              sizeof (CenY),           0},
!     { &CenZ,              sizeof (CenZ),           0},
!     { &ShiftS,            sizeof (ShiftS),         0},
!     { &XlateCen,          sizeof (XlateCen),       0},
!     { &OrigCX,            sizeof (OrigCX),         0},
!     { &OrigCY,            sizeof (OrigCY),         0},
!     { &OrigCZ,            sizeof (OrigCZ),         0},
!     { RotX,               sizeof (RotX),           0},
!     { RotY,               sizeof (RotY),           0},
!     { RotZ,               sizeof (RotZ),           0},
!     { LRotX,              sizeof (LRotX),          0},
!     { LRotY,              sizeof (LRotY),          0},
!     { LRotZ,              sizeof (LRotZ),          0},
!     { LOffset,            sizeof (LOffset),        0},
!     { MatX,               sizeof (MatX),           0},
!     { MatY,               sizeof (MatY),           0},
!     { MatZ,               sizeof (MatZ),           0},
!     { InvX,               sizeof (InvX),           0},
!     { InvY,               sizeof (InvY),           0},
!     { InvZ,               sizeof (InvZ),           0},
!     { &Zoom,              sizeof (Zoom),           0},
!     { &Scale,             sizeof (Scale),          0},
!     { &IScale,            sizeof (IScale),         0},
!      
!     { &XOffset,           sizeof (XOffset),        0},
!     { &YOffset,           sizeof (YOffset),        0},
!     { &ZOffset,           sizeof (ZOffset),        0},
       
      /* transfor.h */
!     { &UseScreenClip,     sizeof (UseScreenClip),  0},
!     { &DrawAtoms,         sizeof (DrawAtoms),      0},
!     { &DrawBonds,         sizeof (DrawBonds),      0},
!     { &DrawRibbon,        sizeof (DrawRibbon),     0},
!     { &LocalRadius,       sizeof (LocalRadius),  0},
!     { &MaxAtomRadius,     sizeof (MaxAtomRadius),  0},
!     { &MaxBondRadius,     sizeof (MaxBondRadius),  0},
!     { &ZoneBoth,          sizeof (ZoneBoth),       0},
  
      /* bond rotation stuff */
!     { &BRotValue, sizeof (BRotValue), 0},
!     { &BLastRot, sizeof (BLastRot), 0},
!     { BAxis, sizeof (BAxis), 0},
!     { &BSrcAtom, sizeof (BSrcAtom), 0},
!     { &BDstAtom, sizeof (BDstAtom), 0},
!     { &BondSelected, sizeof (BondSelected), 0},
!     { &BondsSelected, sizeof (BondsSelected), 0},
       
  #ifdef MOVIE_DONE
      /* script.c movie stuff */
!     { NewDialValue   ,    sizeof (NewDialValue), 0},
!     { &firstCmd, sizeof (firstCmd), 0},
!     { LastDialValue  ,    sizeof (LastDialValue), 0},
  #endif
       
      { NULL, 0, 0}
--- 221,347 ----
  
     /* graphics.h */
      
!     { DialValue,          sizeof (DialValue),      0 },
  
      /* molecule.h */
!     { &Info,              sizeof (Info),           0 },
!     { &MainGroupCount,    sizeof (MainGroupCount), 0 },
!     { &HetaGroupCount,    sizeof (HetaGroupCount), 0 },
!     { &MainAtomCount,     sizeof (MainAtomCount),  0 },
!     { &HetaAtomCount,     sizeof (HetaAtomCount),  0 },
!     { &CisBondCutOff,     sizeof (CisBondCutOff),  0 },
!     { &MinX,              sizeof (MinX),           0 },
!     { &MinY,              sizeof (MinY),           0 },
!     { &MinZ,              sizeof (MinZ),           0 },
!     { &MaxX,              sizeof (MaxX),           0 },
!     { &MaxY,              sizeof (MaxY),           0 },
!     { &MaxZ,              sizeof (MaxZ),           0 },
!     { &HMinMaxFlag,       sizeof (HMinMaxFlag),    0 },
!     { &MMinMaxFlag,       sizeof (MMinMaxFlag),    0 },
!     { &MinMainTemp,       sizeof (MinMainTemp),    0 },
!     { &MaxMainTemp,       sizeof (MaxMainTemp),    0 },
!     { &MinHetaTemp,       sizeof (MinHetaTemp),    0 },
!     { &MaxHetaTemp,       sizeof (MaxHetaTemp),    0 },
!     { &MinMainRes,        sizeof (MinMainRes),     0 },
!     { &MaxMainRes,        sizeof (MaxMainRes),     0 },
!     { &MinHetaRes,        sizeof (MinHetaRes),     0 },
!     { &MaxHetaRes,        sizeof (MaxHetaRes),     0 },
!     { &MinAltl,           sizeof (MinAltl),        0 },
!     { &MaxAltl,           sizeof (MaxAltl),        0 },
!     { &CurMolecule,       sizeof (CurMolecule),    0 },
!     { &CurChain,          sizeof (CurChain),       0 },
!     { &CurGroup,          sizeof (CurGroup),       0 },
!     { &CurAtom,           sizeof (CurAtom),        0 },
!     { &IntList,           sizeof (IntList),        0 },
!     { &Database,          sizeof (Database),       0 },
!     { UserMask,           sizeof (UserMask),       0 },
!     { &MinHBondDist,      sizeof (MinHBondDist),   0 },
!     { &MaxHBondDist,      sizeof (MaxHBondDist),   0 },
!     { &MinBondDist,       sizeof (MinBondDist),    0 },
!     { &MaxBondDist,       sizeof (MaxBondDist),    0 },
!     { &ElemNo,            sizeof (ElemNo),         0 },
!     { &ResNo,             sizeof (ResNo),          0 },
!     { &HasHydrogen,       sizeof (HasHydrogen),    0 },
!     { &MaskCount,         sizeof (MaskCount),      0 },
!     { &NMRModel,          sizeof (NMRModel),       0 },
!     { &NullBonds,         sizeof (NullBonds),      0 },
!     { &MarkAtoms,         sizeof (MarkAtoms),      0 },
!     { &HBondChainsFlag,   sizeof (HBondChainsFlag), 0 },
  
      /* render.h */
!     { &VoxelsClean,       sizeof (VoxelsClean),    0 },
  
      /* repres.h */
!     { &DotPtr,            sizeof (DotPtr),         0 },
!     { &ProbeRadius,       sizeof (ProbeRadius),    0 },
!     { &iProbeRad,         sizeof (iProbeRad),      0 },
! 
  
      /* command.h */
  
!     { &SelectCount,       sizeof (SelectCount),    0 },
       
      /* transfor.h */
!     { &LastRX,            sizeof (LastRX),         0 },
!     { &LastRY,            sizeof (LastRY),         0 },
!     { &LastRZ,            sizeof (LastRZ),         0 },
!     { &LastTX,            sizeof (LastTX),         0 },
!     { &LastTY,            sizeof (LastTY),         0 },
!     { &LastTZ,            sizeof (LastTZ),         0 },
!     { &CenX,              sizeof (CenX),           0 },
!     { &CenY,              sizeof (CenY),           0 },
!     { &CenZ,              sizeof (CenZ),           0 },
!     { &ShiftS,            sizeof (ShiftS),         0 },
!     { &XlateCen,          sizeof (XlateCen),       0 },
!     { &OrigCX,            sizeof (OrigCX),         0 },
!     { &OrigCY,            sizeof (OrigCY),         0 },
!     { &OrigCZ,            sizeof (OrigCZ),         0 },
!     { RotX,               sizeof (RotX),           0 },
!     { RotY,               sizeof (RotY),           0 },
!     { RotZ,               sizeof (RotZ),           0 },
!     { LRotX,              sizeof (LRotX),          0 },
!     { LRotY,              sizeof (LRotY),          0 },
!     { LRotZ,              sizeof (LRotZ),          0 },
!     { LOffset,            sizeof (LOffset),        0 },
!     { MatX,               sizeof (MatX),           0 },
!     { MatY,               sizeof (MatY),           0 },
!     { MatZ,               sizeof (MatZ),           0 },
!     { InvX,               sizeof (InvX),           0 },
!     { InvY,               sizeof (InvY),           0 },
!     { InvZ,               sizeof (InvZ),           0 },
!     { &Zoom,              sizeof (Zoom),           0 },
!     { &Scale,             sizeof (Scale),          0 },
!     { &IScale,            sizeof (IScale),         0 },
!      
!     { &XOffset,           sizeof (XOffset),        0 },
!     { &YOffset,           sizeof (YOffset),        0 },
!     { &ZOffset,           sizeof (ZOffset),        0 },
       
      /* transfor.h */
!     { &UseScreenClip,     sizeof (UseScreenClip),  0 },
!     { &DrawAtoms,         sizeof (DrawAtoms),      0 },
!     { &DrawSurf,          sizeof (DrawSurf),       0 },
!     { &DrawBonds,         sizeof (DrawBonds),      0 },
!     { &DrawRibbon,        sizeof (DrawRibbon),     0 },
!     { &LocalRadius,       sizeof (LocalRadius),    0 },
!     { &MaxAtomRadius,     sizeof (MaxAtomRadius),  0 },
!     { &MaxBondRadius,     sizeof (MaxBondRadius),  0 },
!     { &ZoneBoth,          sizeof (ZoneBoth),       0 },
  
      /* bond rotation stuff */
!     { &BRotValue, sizeof (BRotValue), 0 },
!     { &BLastRot, sizeof (BLastRot), 0 },
!     { BAxis, sizeof (BAxis), 0 },
!     { &BSrcAtom, sizeof (BSrcAtom), 0 },
!     { &BDstAtom, sizeof (BDstAtom), 0 },
!     { &BondSelected, sizeof (BondSelected), 0 },
!     { &BondsSelected, sizeof (BondsSelected), 0 },
       
  #ifdef MOVIE_DONE
      /* script.c movie stuff */
!     { NewDialValue   ,    sizeof (NewDialValue), 0 },
!     { &firstCmd, sizeof (firstCmd), 0 },
!     { LastDialValue  ,    sizeof (LastDialValue), 0 },
  #endif
       
      { NULL, 0, 0}
